
#ifndef __TTASKER_H
#define __TTASKER_H

#include <task/tsk.h>

#include <tbobject.h>
#include <tdef.h>

class TTasker
:
	public	TBobject
{
public:
	TTasker ( char *name="TASKMGR", word flags = IFL_STD, int varpri = 0, int speedup = 0 );

	virtual	~TTasker();

	static Boolean 	isLoaded();

/*
	Boolean 	TTasker::isLoaded()
	{
		return Boolean(ctask_resident());
	}
*/
	void preempt(Boolean enable = True, Boolean temporary = False);

	int delay(dword ticks);

	word ticks();

	void schedule(Boolean conditional=False);

	void yield();

	tcbptr getCurrentThread();

	int stopMain();

	int startMain();

	int wakeMain();

	int mainLoop(Boolean preemption=True);

};

inline TTasker::TTasker ( char *name, word flags, int varpri, int speedup )
{
	::install_tasker(varpri, speedup, flags, (byte *)name);
}

inline TTasker::~TTasker()
{
	::remove_tasker();
}

inline void TTasker::preempt(Boolean enable, Boolean temporary )
{
	if(enable)
	{
		if(temporary)
			::tsk_ena_preempt();
		else
			::preempt_on();
	}
	else
	{
		if(temporary)
			::tsk_dis_preempt();
		else
			::preempt_off();
	}
}

inline int TTasker::delay(dword ticks)
{
	return ::t_delay(ticks);
}

inline word TTasker::ticks()
{
	return ::ticks_per_sec();
}

inline void TTasker::schedule(Boolean conditional)
{
	if(conditional)
		::c_schedule();
	else
		::schedule();
}

inline void TTasker::yield()
{
	::yield();
}

inline tcbptr TTasker::getCurrentThread()
{
	return ::curr_task();
}

inline int TTasker::stopMain()
{
	return ::stop_task(LNULL);
}

inline int TTasker::startMain()
{
	return ::start_task(LNULL);
}

inline int TTasker::wakeMain()
{
	return ::wake_task(LNULL);
}

inline int TTasker::mainLoop(Boolean preemption)
{
	preempt(preemption);

	return ::t_delay(0);
}

#endif // __TTASKER_H
